Imports System
Imports System.ComponentModel

Imports DevExpress.Xpo
Imports DevExpress.Data.Filtering

Imports DevExpress.ExpressApp
Imports DevExpress.Persistent.Base
Imports DevExpress.Persistent.BaseImpl
Imports DevExpress.Persistent.Validation

<DefaultClassOptions(), NavigationItem(False), CreatableItem(False)> _
Public Class ViewFilterContainerSaved
    Inherits BaseObject
    Private _ViewID As String
    Private _ShortName As String
    Private _Criteria As String
    Private _IsPublic As Boolean = True
    Private _ObjectCreated As DateTime
    Private _UserCreated As User

    Public Sub New(ByVal session As Session)
        MyBase.New(session)
        ' This constructor is used when an object is loaded from a persistent storage.
        ' Do not place any code here or place it only when the IsLoading property is false:
        ' if (!IsLoading){
        '   It is now OK to place your initialization code here.
        ' }
        ' or as an alternative, move your initialization code into the AfterConstruction method.
    End Sub
    Public Overrides Sub AfterConstruction()
        MyBase.AfterConstruction()
        ' Place here your initialization code.
    End Sub
    Protected Overrides Sub OnSaving()
        MyBase.OnSaving()

        If Session.IsNewObject(Me) Then
            ObjectCreated = GetSQLTime(Session)
            UserCreated = Session.GetObjectByKey(Of User)(Session.GetKeyValue(SecuritySystem.CurrentUser))
        End If
    End Sub
    <Size(255), Browsable(False)> _
    Property ViewID As String
        Get
            Return _ViewID
        End Get
        Set(value As String)
            SetPropertyValue("ViewID", _ViewID, value)
        End Set
    End Property
    <Size(255)> _
    <RuleRequiredField("ViewFilterContainerSaved-ShortName", DefaultContexts.Save)> _
    Property ShortName As String
        Get
            Return _ShortName
        End Get
        Set(value As String)
            SetPropertyValue("ShortName", _ShortName, value)
        End Set
    End Property
    <Size(-1)> _
    Property Criteria As String
        Get
            Return _Criteria
        End Get
        Set(value As String)
            SetPropertyValue("Criteria", _Criteria, value)
        End Set
    End Property
    Property IsPublic As Boolean
        Get
            Return _IsPublic
        End Get
        Set(value As Boolean)
            SetPropertyValue("IsPublic", _IsPublic, value)
        End Set
    End Property
    <NonCloneable()> _
    Property ObjectCreated As Date
        Get
            Return _ObjectCreated
        End Get
        Set(value As Date)
            SetPropertyValue("ObjectCreated", _ObjectCreated, value)
        End Set
    End Property
    <NonCloneable()> _
    Property UserCreated As User
        Get
            Return _UserCreated
        End Get
        Set(value As User)
            SetPropertyValue("UserCreated", _UserCreated, value)
        End Set
    End Property
End Class
